// MyToolBar.cpp : implementation file
//

#include "stdafx.h"
#include "Apparition.h"
#include "MyToolBar.h"
#include <afxpriv.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyToolBar

CMyToolBar::CMyToolBar()
{
}

CMyToolBar::~CMyToolBar()
{
}


BEGIN_MESSAGE_MAP(CMyToolBar, CToolBar)
	//{{AFX_MSG_MAP(CMyToolBar)
	ON_MESSAGE(WM_IDLEUPDATECMDUI, OnIdleUpdateCmdUI)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#include "ApparitionDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CMyToolBar message handlers
LRESULT CMyToolBar::OnIdleUpdateCmdUI(WPARAM wParam, LPARAM lParam)
{
	if (IsWindowVisible())
    {
        CFrameWnd* pParent = (CFrameWnd*)GetParent();
		//CApparitionDlg* pParent = (CApparitionDlg*)GetParent();
        if (pParent)
           OnUpdateCmdUI(pParent, (BOOL)wParam);
    }
    return 0L;
}

int CMyToolBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CToolBar::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	LoadToolBar(IDR_MAINFRAME);

	CRect rectBar;
	this->GetWindowRect(&rectBar);
	
	CClientDC dc (this);
    m_font.CreatePointFont (rectBar.Height(), _T ("MS Sans Serif"));
    CFont* pOldFont = dc.SelectObject (&m_font);

    TEXTMETRIC tm;
    dc.GetTextMetrics (&tm);
    int cxChar = tm.tmAveCharWidth;
    int cyChar = tm.tmHeight + tm.tmExternalLeading;

    dc.SelectObject (pOldFont);

    SetButtonInfo (13, IDC_MSN_TEXT, TBBS_SEPARATOR, cxChar * 32);

    CRect rect;
    GetItemRect (13, &rect);
    //rect.bottom = rect.top + (cyChar * 16);

	rect.DeflateRect(0, 2);
    if (!m_editText.Create (WS_CHILD | WS_VISIBLE | WS_BORDER | ES_AUTOHSCROLL  ,
		rect, this, IDC_MSN_TEXT))
        return -1;

    m_editText.SetFont (&m_font);

	return 0;
}

CString CMyToolBar::GetText()
{
	CString str;
	m_editText.GetWindowText(str);
	return str;
}
