// ApparitionDlg.h : header file
//

#if !defined(AFX_APPARITIONDLG_H__BDADFE3B_7C1E_43F5_A843_0CAE2327E502__INCLUDED_)
#define AFX_APPARITIONDLG_H__BDADFE3B_7C1E_43F5_A843_0CAE2327E502__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"

#include "myToolbar.h"
/////////////////////////////////////////////////////////////////////////////
// CApparitionDlg dialog

class CApparitionDlg : public CDialog
{
// Construction
public:
	CApparitionDlg(CWnd* pParent = NULL);	// standard constructor
    virtual BOOL OnToolTipText(UINT uID, NMHDR* pNMHDR, LRESULT* pResult);
    virtual BOOL ContinueModal();

private:
	CMyToolBar    m_wndToolBar;
	CRect  m_rectToolbar;

	CImageList m_ToolbarImagesDisabled;
	CImageList m_ToolbarImagesHot;
	CImageList m_ToolbarImages;
	 // load the high color toolbar images and attach them to m_wndToolBar
	void AttachToolbarImages (UINT inNormalImageID,
							  UINT inDisabledImageID,
							  UINT inHotImageID);

	//for multiple language text display in edit 
	CFont*  m_pFontDefault;
	CFont*  m_pFontMultiLang;

	BOOL m_bHooking;

// Dialog Data
	//{{AFX_DATA(CApparitionDlg)
	enum { IDD = IDD_APPARITION_DIALOG };
	CEdit	m_edit;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CApparitionDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CApparitionDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHook();
	afx_msg void OnIE();
	afx_msg void OnMsnGetActiveChat();
	afx_msg void OnMsnSendChat();
	afx_msg void OnMsnSetChatter();
	afx_msg void OnMsnGetContactList();
	afx_msg void OnMsnTerminator();
	afx_msg void OnThank();
	afx_msg void OnMail();
	afx_msg void OnHelp();
	afx_msg void OnClose();
	afx_msg void OnUpdateHook(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEdit(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMSN(CCmdUI* pCmdUI);
	afx_msg void OnUpdateIE(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLogIn(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMsnGetActiveChat(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMsnSendChat(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMsnSetChatter(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMsnGetContactList(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMsnTerminator(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_APPARITIONDLG_H__BDADFE3B_7C1E_43F5_A843_0CAE2327E502__INCLUDED_)
