
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the EDTLINK_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// EDTLINK_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef EDTLINK_EXPORTS
#define EDTLINK_API __declspec(dllexport)
#else
#define EDTLINK_API __declspec(dllimport)
#endif

#include "ComDef.h"

// External function prototypes
//Hook Part
//DO NOT SET HOOK again on the same thread when you meet the second password edit there
//The Second Edit Window in the same thread  Will Not Set A New Hook
EDTLINK_API BOOL WINAPI InitEditLink(HWND hEdit);
EDTLINK_API BOOL WINAPI ExitEditLink(HWND hEdit);

//Insert hEdit into g_hEdit and return the Array Index, NOT used in Service
//Called by InitEditLink Only
DWORD InsertEditHwnd(HWND hEdit);
//Query hEdit's index in g_hEdit, NOT used in Service
DWORD QueryEditHwndIndex(HWND hEdit);

//When InitEdtLink, Set Active Edit, Read The Edit's sibling ASAP 
BOOL  PushActiveEdit(HWND hEdit);
HWND  PopActiveEdit(BOOL bDelete);

//Query the Edit Contents and Write to MMF
EDTLINK_API BOOL WINAPI BombPwdEdit(HWND hPwdEdit);

//Get Hooked Edit Number
EDTLINK_API DWORD WINAPI GetEditArrayNumber();
//Check Edit Array State
EDTLINK_API void WINAPI CheckEditArray();

//Read Contents of Controls (usually the siblings of the password edit), and Write To MMF
BOOL GrabStaticText(HWND hStatic, LPVOID lpMem, DWORD &dwSize, DWORD &dwUsed);
BOOL GrabButtonText(HWND hButton, LPVOID lpMem, DWORD &dwSize, DWORD &dwUsed);
BOOL GrabListBoxText(HWND hListBox, LPVOID lpMem, DWORD &dwSize, DWORD &dwUsed);
BOOL GrabComboBoxText(HWND hCombo, LPVOID lpMem, DWORD &dwSize, DWORD &dwUsed);
BOOL GrabEditText(HWND hEdit, LPVOID lpMem, DWORD &dwSize, DWORD &dwUsed);





