#ifndef NIGHTMARE_
#define NIGHTMARE_

#include <tchar.h>


// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the NIGHTMARE_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// NIGHTMARE_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef NIGHTMARE_EXPORTS
#define NIGHTMARE_API __declspec(dllexport)
#else
#define NIGHTMARE_API __declspec(dllimport)
#endif

#include "ComDef.h"


BOOL InsertPasswordEditArray(HWND hWnd);
BOOL DeletePasswordEditArray(HWND hWnd);

// External function prototypes
//Hook Part
NIGHTMARE_API BOOL WINAPI InitNightmare(HWND hCallerHwnd);
NIGHTMARE_API BOOL WINAPI ExitNightmare();

//Hook into existing Target Window
NIGHTMARE_API DWORD WINAPI GetChatNumber();
NIGHTMARE_API DWORD WINAPI GetActiveChat();

NIGHTMARE_API BOOL  WINAPI SetActiveChat(DWORD dwActive);
NIGHTMARE_API BOOL  WINAPI SetActiveChatWindow(HWND dwActiveWnd);

NIGHTMARE_API  HWND WINAPI GetChatWindowHandle(DWORD dwIndex);

NIGHTMARE_API  DWORD WINAPI InsertChatWindowHandle(HWND hWnd); //return index, -1 when fail
NIGHTMARE_API  DWORD WINAPI DeleteChatWindowHandle(HWND hWnd);

NIGHTMARE_API HWND WINAPI  GetMSNMainHWND();
NIGHTMARE_API HWND WINAPI GetPasswordEditHandle(DWORD dwIndex);


DWORD InsertBrowserHandle(HWND hWnd);
DWORD DeleteBrowserHandle(HWND hWnd);
NIGHTMARE_API DWORD WINAPI GetBrowserNumber();
NIGHTMARE_API HWND WINAPI GetBrowserWindowHandle(DWORD dwIndex);
void  CheckBrowserHandleArray();

//IE Crash
BOOL IsIECrashDialog(HWND hWnd);
BOOL HandleIECrashDialog(HWND hWnd);

#endif